Unit AME2R_p;
interface
uses
SysUtils, Math, { Delpi }
LStruct, Lfunc;

procedure AME2R(var A :Array of Real; T :Real; M :Integer;
                var E :Array of Real; var R :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real);

implementation

procedure AME2R(var A :Array of Real; T :Real; M :Integer;
                var E :Array of Real; var R :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real);
var
D,I,I1,J,L,N0,NL :Integer;
H,NOR1,RA :Real;
const
N :Integer = 14;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380;
begin
NOR1 := 0.0;
for I:=1 to M do
 begin
  H := 0.0;
  for J:=1 to M do
   begin
    H := H + Abs(A[(I-1)+(J-1)*M]);
_10:
   end;
  if ( NOR1 < H ) 
   then NOR1 := H;
_20:
 end;
NL := Trunc( NOR1*Abs(T) + 1.0 );
H := T/(NL);
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    E[(I-1)+(J-1)*M] := A[(I-1)+(J-1)*M]*H;
_30:
   end;
_40:
 end;
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    R1[(I-1)+(J-1)*M] := E[(I-1)+(J-1)*M];
_50:
   end;
_60:
 end;
if ( N = 1 ) 
 then goto _140;
RA := 1.0/(N);
I1 := N - 1;
_70:
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    R1[(I-1)+(J-1)*M] := R1[(I-1)+(J-1)*M]*RA;
_80:
   end;
  R1[(I-1)+(I-1)*M] := R1[(I-1)+(I-1)*M] + 1.0;
_90:
 end;
for L:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for J:=1 to M do
     begin
      RA := RA + E[(I-1)+(J-1)*M]*R1[(J-1)+(L-1)*M];
_100:
     end;
    R[I-1] := RA;
_110:
   end;
  for I:=1 to M do
   begin
    R1[(I-1)+(L-1)*M] := R[I-1];
_120:
   end;
_130:
 end;
RA := 1.0/(I1);
I1 := I1 - 1;
if ( I1 <> 0 ) 
 then goto _70;
_140:
for I:=1 to M do
 begin
  R1[(I-1)+(I-1)*M] := R1[(I-1)+(I-1)*M] + 1.0;
_150:
 end;
D := NL;
N0 := NL;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    E[(I-1)+(J-1)*M] := 0.0;
_160:
   end;
  E[(J-1)+(J-1)*M] := 1.0;
_170:
 end;
I1 := 1;
goto _270;
_180:
case I1 of
 1: goto _190;
 2: goto _230;
end;
_190:
for L:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for J:=1 to M do
     begin
      RA := RA + R1[(I-1)+(J-1)*M]*R1[(J-1)+(L-1)*M];
_200:
     end;
    R2[(I-1)+(L-1)*M] := RA;
_210:
   end;
_220:
 end;
I1 := 2;
goto _270;
_230:
for L:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for J:=1 to M do
     begin
      RA := RA + R2[(I-1)+(J-1)*M]*R2[(J-1)+(L-1)*M];
_240:
     end;
    R1[(I-1)+(L-1)*M] := RA;
_250:
   end;
_260:
 end;
I1 := 1;
_270:
N0 := D div 2;
if ( D - 2*N0 = 0 ) 
 then goto _380;
case I1 of
 1: goto _280;
 2: goto _330;
end;
_280:
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for L:=1 to M do
     begin
      RA := RA + R1[(I-1)+(L-1)*M]*E[(L-1)+(J-1)*M];
_290:
     end;
    R[I-1] := RA;
_300:
   end;
  for I:=1 to M do
   begin
    E[(I-1)+(J-1)*M] := R[I-1];
_310:
   end;
_320:
 end;
goto _380;
_330:
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for L:=1 to M do
     begin
      RA := RA + R2[(I-1)+(L-1)*M]*E[(L-1)+(J-1)*M];
_340:
     end;
    R[I-1] := RA;
_350:
   end;
  for I:=1 to M do
   begin
    E[(I-1)+(J-1)*M] := R[I-1];
_360:
   end;
_370:
 end;
_380:
D := N0;
if ( D <> 0 ) 
 then goto _180;
end;

end.
